#version 420

layout(triangles) in;
layout(triangle_strip,max_vertices=9) out;

layout (location=0) in vec3 Colour[];

out NVertex {
  vec3 Colour;
  vec3 Position;
  vec3 Normal;
} Out;

uniform TransBlock {
    mat4 mm, vm, pm, vpm;
    vec4 eyepos;
  } trb;

#define OUT_VERTEX(p,c) \
  Out.Normal = nv; \
  Out.Position = p.xyz; \
  Out.Colour = c; \
  gl_Position = trb.vpm * p; \
  EmitVertex ();

void main ( void )
{
  int  i;
  vec3 v1, v2, nv, acol[4];
  vec4 apos[4];

  v1 = gl_in[1].gl_Position.xyz - gl_in[0].gl_Position.xyz;
  v2 = gl_in[2].gl_Position.xyz - gl_in[0].gl_Position.xyz;
  nv = normalize ( cross ( v1, v2 ) );
  apos[0] = 0.5*(gl_in[0].gl_Position + gl_in[1].gl_Position);
  apos[1] = 0.5*(gl_in[1].gl_Position + gl_in[2].gl_Position);
  apos[2] = 0.5*(gl_in[2].gl_Position + gl_in[0].gl_Position);
  apos[3] = (gl_in[0].gl_Position + gl_in[1].gl_Position+gl_in[2].gl_Position)/3.0;
  acol[0] = 0.5*(Colour[0] + Colour[1]);
  acol[1] = 0.5*(Colour[1] + Colour[2]);
  acol[2] = 0.5*(Colour[2] + Colour[0]);
  acol[3] = (Colour[0] + Colour[1]+Colour[2])/3.0;

  for ( i = 0; i < 3; i++ ) {
    OUT_VERTEX ( apos[3], acol[3] )
    OUT_VERTEX ( gl_in[i].gl_Position, Colour[i] )
    OUT_VERTEX ( apos[i], acol[i] )
    EndPrimitive ();
  }
} /*main*/
