
#define MAX_PATCH_DEGREE 10

typedef struct BezierPatchObjf {
    GLint  udeg, vdeg, dim, stride_u, stride_v, stride_p, stride_q, npatches;
    GLuint buf[4];
  } BezierPatchObjf;

extern const GLchar *UCPNames[];
extern const GLchar *UCPINames[];
extern const GLchar *UBezPatchNames[];
extern const GLchar *UTexCoordNames[];

extern GLuint bezpbbp, cpbbp, cpibbp, txcbp;
extern GLint  bezpbsize;

void GetAccessToBezPatchUniformBlocks ( GLuint program_id );

BezierPatchObjf* EnterBezierPatches ( GLint udeg, GLint vdeg, GLint dim,
                      GLint np, GLint nq, GLint ncp, const GLfloat *cp,
                      GLint stride_p, GLint stride_q, GLint stride_u, GLint stride_v,
                      const GLfloat *colour );
BezierPatchObjf* EnterBezierPatchesElem ( GLint udeg, GLint vdeg, GLint dim,
                      int npatches, int ncp,
                      const GLfloat *cp, const GLint *ind,
                      const GLfloat *colour );

void DrawBezierPatches ( BezierPatchObjf *bp );
void DrawBezierNets ( BezierPatchObjf *bp );

void DeleteBezierPatches ( BezierPatchObjf *bp );

